"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var glob_1 = require("glob");
var graphql_resolvers_finder_1 = require("graphql-resolvers-finder");
function findResolver(glob, baseDir, typeName, fieldName, schemaPointer) {
    return __awaiter(this, void 0, void 0, function () {
        var relevantFiles, foundResolvers, keys, _i, keys_1, key, item, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log(chalk_1.default.gray("Looking for source code files using glob \"" + glob + "\"..."));
                    relevantFiles = glob_1.sync(glob, {
                        absolute: true,
                        cwd: process.cwd(),
                    });
                    if (!(relevantFiles.length === 0)) return [3 /*break*/, 1];
                    console.log(chalk_1.default.redBright("Unable to find any matching for \"" + glob + "\" expression!"));
                    return [2 /*return*/];
                case 1:
                    console.log(chalk_1.default.gray("Found total of " + relevantFiles.length + " source code files."));
                    if (typeName && fieldName) {
                        console.log(chalk_1.default.white("Looking for " + typeName + "." + fieldName + "..."));
                    }
                    else if (typeName && !fieldName) {
                        console.log(chalk_1.default.white("Looking for " + typeName + "..."));
                    }
                    else {
                        console.log(chalk_1.default.white("Looking for resolvers..."));
                    }
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, graphql_resolvers_finder_1.extractResolversFromSchema(relevantFiles, baseDir, typeName, fieldName, schemaPointer)];
                case 3:
                    foundResolvers = _a.sent();
                    keys = Object.keys(foundResolvers);
                    if (keys.length === 0) {
                        console.log(chalk_1.default.redBright('Unable to find any resolvers!'));
                        return [2 /*return*/];
                    }
                    else {
                        console.log(chalk_1.default.white("Found total of " + keys.length + " resolvers:"));
                        for (_i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
                            key = keys_1[_i];
                            item = foundResolvers[key];
                            console.log(chalk_1.default.white("\t" + key + " -> " + item.filepath + " (line " + item.node.loc.start.line + ", col " + item.node.loc.start.column + ")"));
                        }
                    }
                    return [3 /*break*/, 5];
                case 4:
                    e_1 = _a.sent();
                    console.log(chalk_1.default.redBright(e_1));
                    process.exit(1);
                    return [3 /*break*/, 5];
                case 5: return [2 /*return*/];
            }
        });
    });
}
exports.findResolver = findResolver;
//# sourceMappingURL=find.js.map