#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var commander = require("commander");
var path_1 = require("path");
var list_1 = require("./commands/list");
var find_1 = require("./commands/find");
commander
    .command('list')
    .description('Lists all found resolvers')
    .option('-i, --input <path>', 'A glob expression pointing to your source code files', path_1.join(process.cwd(), './*.{ts,js}'))
    .option('-s, --schema <point-to-schema>', 'A pointer to your GraphQL schema, optional', path_1.join(process.cwd(), './*.{ts,js}'))
    .option('-b, --base-dir <path>', 'A path to be used as base dir', null)
    .action(function (cmd) {
    list_1.listResolvers(cmd.input, cmd.baseDir, cmd.schemaPointer);
});
commander
    .command('find')
    .description('Find a specific resolver')
    .option('-i, --input <path>', 'A glob expression pointing to your source code files', path_1.join(process.cwd(), './*.{ts,js}'))
    .option('-s, --type <type-name>', 'The type name, optional if schema has been provided', null)
    .option('-s, --field <field-name>', 'The field name, optional', null)
    .option('-s, --schema <point-to-schema>', 'A pointer to your GraphQL schema, optional if type has been provided', null)
    .option('-b, --base-dir <path>', 'A path to be used as base dir, optional', null)
    .action(function (cmd) {
    find_1.findResolver(cmd.input, cmd.baseDir, cmd.type, cmd.field, cmd.schema);
});
commander.command('*').action(function () { return commander.help(); });
commander.parse(process.argv);
//# sourceMappingURL=index.js.map